From 736cbcad40735bc6a64a4fbe1609f8c372c93746 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Mar 11 2020 23:51:38 +0000
Subject: [PATCH 115/2232] Move header include path to rust/cxx.h


---

diff --git a/BUCK b/BUCK
index 2d12753..2f80c9b 100644
--- a/BUCK
+++ b/BUCK
@@ -38,11 +38,11 @@ rust_binary(
 
 cxx_library(
     name = "core",
-    srcs = ["src/cxxbridge.cc"],
+    srcs = ["src/cxx.cc"],
     visibility = ["PUBLIC"],
-    header_namespace = "cxxbridge",
+    header_namespace = "rust",
     exported_headers = {
-        "cxxbridge.h": "include/cxxbridge.h",
+        "cxx.h": "include/cxx.h",
     },
     exported_linker_flags = ["-lstdc++"],
 )
diff --git a/BUILD b/BUILD
index 0405df1..db22203 100644
--- a/BUILD
+++ b/BUILD
@@ -3,7 +3,7 @@ load("//tools/bazel:rust.bzl", "rust_binary", "rust_library")
 rust_library(
     name = "cxx",
     srcs = glob(["src/**/*.rs"]),
-    data = ["src/gen/include/cxxbridge.h"],
+    data = ["src/gen/include/cxx.h"],
     visibility = ["//visibility:public"],
     deps = [
         ":core-lib",
@@ -23,7 +23,7 @@ rust_library(
 rust_binary(
     name = "codegen",
     srcs = glob(["cmd/src/**/*.rs"]),
-    data = ["cmd/src/gen/include/cxxbridge.h"],
+    data = ["cmd/src/gen/include/cxx.h"],
     visibility = ["//visibility:public"],
     deps = [
         "//third-party:anyhow",
@@ -39,16 +39,16 @@ rust_binary(
 
 cc_library(
     name = "core",
-    hdrs = ["include/cxxbridge.h"],
-    include_prefix = "cxxbridge",
+    hdrs = ["include/cxx.h"],
+    include_prefix = "rust",
     strip_include_prefix = "include",
     visibility = ["//visibility:public"],
 )
 
 cc_library(
     name = "core-lib",
-    srcs = ["src/cxxbridge.cc"],
-    hdrs = ["include/cxxbridge.h"],
+    srcs = ["src/cxx.cc"],
+    hdrs = ["include/cxx.h"],
 )
 
 rust_library(
diff --git a/build.rs b/build.rs
index ea562c2..bdda779 100644
--- a/build.rs
+++ b/build.rs
@@ -1,8 +1,8 @@
 fn main() {
     cc::Build::new()
-        .file("src/cxxbridge.cc")
+        .file("src/cxx.cc")
         .flag("-std=c++11")
         .compile("cxxbridge01");
-    println!("cargo:rerun-if-changed=src/cxxbridge.cc");
-    println!("cargo:rerun-if-changed=include/cxxbridge.h");
+    println!("cargo:rerun-if-changed=src/cxx.cc");
+    println!("cargo:rerun-if-changed=include/cxx.h");
 }
diff --git a/cmd/src/main.rs b/cmd/src/main.rs
index 26b6ef6..06b3bbe 100644
--- a/cmd/src/main.rs
+++ b/cmd/src/main.rs
@@ -14,7 +14,7 @@ use structopt::StructOpt;
     usage = "\
     cxxbridge <input>.rs              Emit .cc file for bridge to stdout
     cxxbridge <input>.rs --header     Emit .h file for bridge to stdout
-    cxxbridge --header                Emit cxxbridge.h header to stdout",
+    cxxbridge --header                Emit rust/cxx.h header to stdout",
     help_message = "Print help information",
     version_message = "Print version information"
 )]
diff --git a/demo-cxx/demo.h b/demo-cxx/demo.h
index a579986..fafc474 100644
--- a/demo-cxx/demo.h
+++ b/demo-cxx/demo.h
@@ -1,5 +1,5 @@
 #pragma once
-#include "cxxbridge/cxxbridge.h"
+#include "rust/cxx.h"
 #include <memory>
 #include <string>
 
diff --git a/gen/include.rs b/gen/include.rs
index e34d9d0..a4b416a 100644
--- a/gen/include.rs
+++ b/gen/include.rs
@@ -1,6 +1,6 @@
 use std::fmt::{self, Display};
 
-pub static HEADER: &str = include_str!("include/cxxbridge.h");
+pub static HEADER: &str = include_str!("include/cxx.h");
 
 pub fn get(guard: &str) -> &'static str {
     let ifndef = format!("#ifndef {}", guard);
@@ -10,7 +10,7 @@ pub fn get(guard: &str) -> &'static str {
     if let (Some(begin), Some(end)) = (begin, end) {
         &HEADER[begin..end + endif.len()]
     } else {
-        panic!("not found in cxxbridge.h header: {}", guard)
+        panic!("not found in cxx.h header: {}", guard)
     }
 }
 
diff --git a/gen/write.rs b/gen/write.rs
index 601f7ef..9ab98fa 100644
--- a/gen/write.rs
+++ b/gen/write.rs
@@ -126,7 +126,7 @@ fn write_include_cxxbridge(out: &mut OutFile, apis: &[Api], types: &Types) {
     out.begin_block("inline namespace cxxbridge01");
 
     if needs_rust_box || needs_manually_drop || needs_maybe_uninit {
-        writeln!(out, "// #include \"cxxbridge.h\"");
+        writeln!(out, "// #include \"rust/cxx.h\"");
     }
 
     if needs_rust_box {
diff --git a/include/cxx.h b/include/cxx.h
new file mode 100644
index 0000000..81bdad5
--- /dev/null
+++ b/include/cxx.h
@@ -0,0 +1,155 @@
+#pragma once
+#include <array>
+#include <cstdint>
+#include <iosfwd>
+#include <string>
+#include <type_traits>
+
+namespace rust {
+inline namespace cxxbridge01 {
+
+struct unsafe_bitcopy_t;
+
+class String final {
+public:
+  String() noexcept;
+  String(const String &) noexcept;
+  String(String &&) noexcept;
+  ~String() noexcept;
+
+  String(const std::string &);
+  String(const char *);
+
+  String &operator=(const String &) noexcept;
+  String &operator=(String &&) noexcept;
+
+  explicit operator std::string() const;
+
+  // Note: no null terminator.
+  const char *data() const noexcept;
+  size_t size() const noexcept;
+  size_t length() const noexcept;
+
+  // Internal API only intended for the cxxbridge code generator.
+  String(unsafe_bitcopy_t, const String &) noexcept;
+
+private:
+  // Size and alignment statically verified by rust_string.rs.
+  std::array<uintptr_t, 3> repr;
+};
+
+class Str final {
+public:
+  Str() noexcept;
+  Str(const Str &) noexcept;
+
+  Str(const std::string &);
+  Str(const char *);
+  Str(std::string &&) = delete;
+
+  Str &operator=(Str) noexcept;
+
+  explicit operator std::string() const;
+
+  // Note: no null terminator.
+  const char *data() const noexcept;
+  size_t size() const noexcept;
+  size_t length() const noexcept;
+
+  // Repr is PRIVATE; must not be used other than by our generated code.
+  //
+  // Not necessarily ABI compatible with &str. Codegen will translate to
+  // cxx::rust_str::RustStr which matches this layout.
+  struct Repr {
+    const char *ptr;
+    size_t len;
+  };
+  Str(Repr) noexcept;
+  explicit operator Repr() noexcept;
+
+private:
+  Repr repr;
+};
+
+#ifndef CXXBRIDGE01_RUST_BOX
+#define CXXBRIDGE01_RUST_BOX
+template <typename T> class Box final {
+public:
+  using value_type = T;
+  using const_pointer = typename std::add_pointer<
+      typename std::add_const<value_type>::type>::type;
+  using pointer = typename std::add_pointer<value_type>::type;
+
+  Box(const Box &other) : Box(*other) {}
+  Box(Box &&other) noexcept : ptr(other.ptr) { other.ptr = nullptr; }
+  Box(const T &val) {
+    this->uninit();
+    ::new (this->ptr) T(val);
+  }
+  Box &operator=(const Box &other) {
+    if (this != &other) {
+      if (this->ptr) {
+        **this = *other;
+      } else {
+        this->uninit();
+        ::new (this->ptr) T(*other);
+      }
+    }
+    return *this;
+  }
+  Box &operator=(Box &&other) noexcept {
+    if (this->ptr) {
+      this->drop();
+    }
+    this->ptr = other.ptr;
+    other.ptr = nullptr;
+    return *this;
+  }
+  ~Box() noexcept {
+    if (this->ptr) {
+      this->drop();
+    }
+  }
+
+  const T *operator->() const noexcept { return this->ptr; }
+  const T &operator*() const noexcept { return *this->ptr; }
+  T *operator->() noexcept { return this->ptr; }
+  T &operator*() noexcept { return *this->ptr; }
+
+  // Important: requires that `raw` came from an into_raw call. Do not pass a
+  // pointer from `new` or any other source.
+  static Box from_raw(T *raw) noexcept {
+    Box box;
+    box.ptr = raw;
+    return box;
+  }
+
+  T *into_raw() noexcept {
+    T *raw = this->ptr;
+    this->ptr = nullptr;
+    return raw;
+  }
+
+private:
+  Box() noexcept {}
+  void uninit() noexcept;
+  void drop() noexcept;
+  T *ptr;
+};
+#endif // CXXBRIDGE01_RUST_BOX
+
+std::ostream &operator<<(std::ostream &, const String &);
+std::ostream &operator<<(std::ostream &, const Str &);
+
+// Snake case aliases for use in code that uses this style for type names.
+using string = String;
+using str = Str;
+template <class T> using box = Box<T>;
+
+struct unsafe_bitcopy_t {
+  explicit unsafe_bitcopy_t() = default;
+};
+constexpr unsafe_bitcopy_t unsafe_bitcopy{};
+
+} // namespace cxxbridge01
+} // namespace rust
diff --git a/src/cxx.cc b/src/cxx.cc
new file mode 100644
index 0000000..f7b02ec
--- /dev/null
+++ b/src/cxx.cc
@@ -0,0 +1,166 @@
+#include "../include/cxx.h"
+#include <cstring>
+#include <iostream>
+#include <memory>
+#include <stdexcept>
+
+extern "C" {
+const char *cxxbridge01$cxx_string$data(const std::string &s) noexcept {
+  return s.data();
+}
+
+size_t cxxbridge01$cxx_string$length(const std::string &s) noexcept {
+  return s.length();
+}
+
+// rust::String
+void cxxbridge01$string$new(rust::String *self) noexcept;
+void cxxbridge01$string$clone(rust::String *self,
+                              const rust::String &other) noexcept;
+bool cxxbridge01$string$from(rust::String *self, const char *ptr,
+                             size_t len) noexcept;
+void cxxbridge01$string$drop(rust::String *self) noexcept;
+const char *cxxbridge01$string$ptr(const rust::String *self) noexcept;
+size_t cxxbridge01$string$len(const rust::String *self) noexcept;
+
+// rust::Str
+bool cxxbridge01$str$valid(const char *ptr, size_t len) noexcept;
+} // extern "C"
+
+namespace rust {
+inline namespace cxxbridge01 {
+
+String::String() noexcept { cxxbridge01$string$new(this); }
+
+String::String(const String &other) noexcept {
+  cxxbridge01$string$clone(this, other);
+}
+
+String::String(String &&other) noexcept {
+  this->repr = other.repr;
+  cxxbridge01$string$new(&other);
+}
+
+String::~String() noexcept { cxxbridge01$string$drop(this); }
+
+String::String(const std::string &s) {
+  auto ptr = s.data();
+  auto len = s.length();
+  if (!cxxbridge01$string$from(this, ptr, len)) {
+    throw std::invalid_argument("data for rust::String is not utf-8");
+  }
+}
+
+String::String(const char *s) {
+  auto len = strlen(s);
+  if (!cxxbridge01$string$from(this, s, len)) {
+    throw std::invalid_argument("data for rust::String is not utf-8");
+  }
+}
+
+String &String::operator=(const String &other) noexcept {
+  if (this != &other) {
+    cxxbridge01$string$drop(this);
+    cxxbridge01$string$clone(this, other);
+  }
+  return *this;
+}
+
+String &String::operator=(String &&other) noexcept {
+  if (this != &other) {
+    cxxbridge01$string$drop(this);
+    this->repr = other.repr;
+    cxxbridge01$string$new(&other);
+  }
+  return *this;
+}
+
+String::operator std::string() const {
+  return std::string(this->data(), this->size());
+}
+
+const char *String::data() const noexcept {
+  return cxxbridge01$string$ptr(this);
+}
+
+size_t String::size() const noexcept { return cxxbridge01$string$len(this); }
+
+size_t String::length() const noexcept { return cxxbridge01$string$len(this); }
+
+String::String(unsafe_bitcopy_t, const String &bits) noexcept
+    : repr(bits.repr) {}
+
+std::ostream &operator<<(std::ostream &os, const String &s) {
+  os.write(s.data(), s.size());
+  return os;
+}
+
+Str::Str() noexcept : repr(Repr{reinterpret_cast<const char *>(this), 0}) {}
+
+Str::Str(const Str &) noexcept = default;
+
+Str::Str(const std::string &s) : repr(Repr{s.data(), s.length()}) {
+  if (!cxxbridge01$str$valid(this->repr.ptr, this->repr.len)) {
+    throw std::invalid_argument("data for rust::Str is not utf-8");
+  }
+}
+
+Str::Str(const char *s) : repr(Repr{s, strlen(s)}) {
+  if (!cxxbridge01$str$valid(this->repr.ptr, this->repr.len)) {
+    throw std::invalid_argument("data for rust::Str is not utf-8");
+  }
+}
+
+Str &Str::operator=(Str other) noexcept {
+  this->repr = other.repr;
+  return *this;
+}
+
+Str::operator std::string() const {
+  return std::string(this->data(), this->size());
+}
+
+const char *Str::data() const noexcept { return this->repr.ptr; }
+
+size_t Str::size() const noexcept { return this->repr.len; }
+
+size_t Str::length() const noexcept { return this->repr.len; }
+
+Str::Str(Repr repr_) noexcept : repr(repr_) {}
+
+Str::operator Repr() noexcept { return this->repr; }
+
+std::ostream &operator<<(std::ostream &os, const Str &s) {
+  os.write(s.data(), s.size());
+  return os;
+}
+
+} // namespace cxxbridge01
+} // namespace rust
+
+extern "C" {
+void cxxbridge01$unique_ptr$std$string$null(
+    std::unique_ptr<std::string> *ptr) noexcept {
+  new (ptr) std::unique_ptr<std::string>();
+}
+void cxxbridge01$unique_ptr$std$string$new(std::unique_ptr<std::string> *ptr,
+                                           std::string *value) noexcept {
+  new (ptr) std::unique_ptr<std::string>(new std::string(std::move(*value)));
+}
+void cxxbridge01$unique_ptr$std$string$raw(std::unique_ptr<std::string> *ptr,
+                                           std::string *raw) noexcept {
+  new (ptr) std::unique_ptr<std::string>(raw);
+}
+const std::string *cxxbridge01$unique_ptr$std$string$get(
+    const std::unique_ptr<std::string> &ptr) noexcept {
+  return ptr.get();
+}
+std::string *cxxbridge01$unique_ptr$std$string$release(
+    std::unique_ptr<std::string> &ptr) noexcept {
+  return ptr.release();
+}
+void cxxbridge01$unique_ptr$std$string$drop(
+    std::unique_ptr<std::string> *ptr) noexcept {
+  ptr->~unique_ptr();
+}
+} // extern "C"
diff --git a/src/lib.rs b/src/lib.rs
index 006159a..316918f 100644
--- a/src/lib.rs
+++ b/src/lib.rs
@@ -310,9 +310,9 @@
 //! <tr><td></td><td></td><td></td></tr>
 //! </table>
 //!
-//! The C++ API of the `cxxbridge` namespace is defined by the
-//! *include/cxxbridge.h* file in https://github.com/dtolnay/cxx. You will need
-//! to include this header in your C++ code when working with those types.
+//! The C++ API of the `rust` namespace is defined by the *include/cxx.h* file
+//! in https://github.com/dtolnay/cxx. You will need to include this header in
+//! your C++ code when working with those types.
 //!
 //! The following types are intended to be supported "soon" but are just not
 //! implemented yet. I don't expect any of these to be hard to make work but
@@ -463,10 +463,10 @@ fn try_generate_bridge(rust_source_file: &Path) -> Result<cc::Build> {
     let mut build = paths::cc_build();
     build.file(&bridge_path);
 
-    let ref cxxbridge_h = paths::include_dir()?.join("cxxbridge").join("cxxbridge.h");
-    let _ = fs::create_dir_all(cxxbridge_h.parent().unwrap());
-    let _ = fs::remove_file(cxxbridge_h);
-    let _ = fs::write(cxxbridge_h, gen::include::HEADER);
+    let ref cxx_h = paths::include_dir()?.join("rust").join("cxx.h");
+    let _ = fs::create_dir_all(cxx_h.parent().unwrap());
+    let _ = fs::remove_file(cxx_h);
+    let _ = fs::write(cxx_h, gen::include::HEADER);
 
     Ok(build)
 }
diff --git a/tests/ffi/tests.h b/tests/ffi/tests.h
index f41cc5e..7cff6fa 100644
--- a/tests/ffi/tests.h
+++ b/tests/ffi/tests.h
@@ -1,5 +1,5 @@
 #pragma once
-#include "cxxbridge/cxxbridge.h"
+#include "rust/cxx.h"
 #include <memory>
 #include <string>
 

